<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>49.10</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- awesome 6.0.0 -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0/css/all.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">DANH SÁCH ĐƠN HÀNG</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <span class="brand-text font-weight-light">Devcamp</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">

                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
                 with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link active">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Dashboard
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="./index.html" class="nav-link active">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v1</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1 class="m-0">DANH SÁCH ĐƠN HÀNG</h1>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">DANH SÁCH ĐƠN HÀNG</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->
            <!-- filter -->
            <div class="container jumbotron">
                <div class="col-12">
                    <div class="row form-group">
                        <div class="col-sm-6">
                            <div class="row form-group">
                                <div class="col-4">
                                    <label for="">Loại Pizza</label>
                                </div>
                                <div class="col-8">
                                    <select id="pizza-select" class="form-control select2">
                                        <option value="none">Chọn loại Pizza</option>
                                        <option value="Seafood">Hải sản</option>
                                        <option value="Hawaii">Hawaii</option>
                                        <option value="Bacon">Thịt hun khói</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-6">
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="status-order-select">Trạng thái order</label>
                                </div>
                                <div class="col-8">
                                    <select id="status-order-select" class="form-control select2">
                                        <option value="none">Trạng thái đơn hàng</option>
                                        <option value="open">Open</option>
                                        <option value="confirmed">Đã xác nhận</option>
                                        <option value="cancel">Đã hủy</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-12 text-center">
                            <button class="btn btn-primary w-25" id="btn-filter">Lọc</button>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <div class="w-25 mb-4">
                        <button class="btn btn-success w-25 insert-order">Thêm</button>
                    </div>
                    <table id="course-table" class="bg-light table table-striped table-bordered table-hover">
                        <thead>
                            <tr>
                                <th>STT</th>
                                <th>Order ID</th>
                                <th>Kích cỡ combo</th>
                                <th>Loại Pizza</th>
                                <th>Nước uống</th>
                                <th>Thành tiền</th>
                                <th>Họ và tên</th>
                                <th>Số điện thoại</th>
                                <th>Trạng thái</th>
                                <th>Chi tiết</th>
                            </tr>
                        </thead>
                        <tbody>

                        </tbody>
                    </table>

                </div><!-- /.container-fluid -->
            </section>
            <!-- modal -->
            <!-- modal thêm -->
            <div>
                <div id="insert-order-modal" class="modal fade">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header bg-primary">
                                <h5 class="modal-title" id="h5-modal-title">Order Detail</h5>
                                <button class="close" data-dismiss="modal">&times;</button>
                            </div>
                            <div class="modal-body">
                                <form>
                                    <!-- kích cỡ -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-kichCo">Kích cỡ</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <select id="inp-insert-kichCo" class="form-control select2">
                                                <option value="none">Chọn Combo</option>
                                                <option value="S">Small</option>
                                                <option value="M">Medium</option>
                                                <option value="L">Large</option>
                                            </select>
                                        </div>
                                    </div>
                                    <!-- đường kính -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-duong-kinh">Đường kính</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-insert-duong-kinh"
                                                class="form-control bg-white">
                                        </div>
                                    </div>
                                    <!-- sườn -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-suon">Sườn</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-insert-suon"
                                                class="form-control  bg-white">
                                        </div>
                                    </div>
                                    <!-- salad -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-salad">Salad</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-insert-salad"
                                                class="form-control  bg-white">
                                        </div>
                                    </div>
                                    <!-- số lượng nước -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-soLuongNuoc">Số lượng nước</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-insert-soLuongNuoc"
                                                class="form-control  bg-white">
                                        </div>
                                    </div>
                                    <!-- thành tiền -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-thanhTien">Thành tiền</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-insert-thanhTien"
                                                class="form-control  bg-white">
                                        </div>
                                    </div>
                                    <!-- loại pizza -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-loaiPizza">Loại Pizza</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <select id="inp-insert-loaiPizza" class="form-control select2">
                                                <option value="none">Chọn loại Pizza</option>
                                                <option value="Seafood">Hải sản</option>
                                                <option value="Hawaii">Hawaii</option>
                                                <option value="Bacon">Thịt hun khói</option>
                                            </select>
                                        </div>
                                    </div>
                                    <!-- giảm giá -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-thanhTien">Giảm giá</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-insert-giamgia"
                                                class="form-control  bg-white">
                                        </div>
                                    </div>
                                    <!-- id voucher -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-idVourcher">Id voucher</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="inp-insert-idVourcher" class="form-control">
                                        </div>
                                    </div>
                                    <!-- id loại nước uống -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-idLoaiNuocUong">Id Loại nước uống</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <select id="inp-insert-idLoaiNuocUong" class="form-control select2">
                                            </select>
                                        </div>
                                    </div>
                                    <!-- họ và tên -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-hoTen">Họ và tên</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="inp-insert-hoTen" class="form-control">
                                        </div>
                                    </div>
                                    <!-- email -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-email">Email</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="inp-insert-email" class="form-control">
                                        </div>
                                    </div>
                                    <!-- sdt -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-soDienThoai">Số điện thoại</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="inp-insert-soDienThoai" class="form-control">
                                        </div>
                                    </div>
                                    <!-- địa chỉ -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-dia-chi">Địa chỉ</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="inp-insert-dia-chi" class="form-control">
                                        </div>
                                    </div>
                                    <!-- lời nhắn -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-loiNhan">Lời nhắn</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="inp-insert-loiNhan" class="form-control">
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button class="btn btn-success" id="btn-insert-order">Thêm order</button>
                                <button class="btn btn-warning" id="btn-cancel" data-dismiss="modal">Cancel</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- modal sửa -->
            <div>
                <div id="detail-order-modal" class="modal fade" tabindex="-1">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header bg-primary">
                                <h5 class="modal-title" id="h5-modal-title">Order Detail</h5>
                                <button class="close" data-dismiss="modal">&times;</button>
                            </div>
                            <div class="modal-body">
                                <form>
                                    <!-- order id -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-orderId">Order Id</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-orderId" class="form-control">
                                        </div>
                                    </div>
                                    <!-- họ và tên -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-hoTen">Họ và tên</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-hoTen" class="form-control">
                                        </div>
                                    </div>
                                    <!-- email -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-email">Email</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-email" class="form-control">
                                        </div>
                                    </div>
                                    <!-- sdt -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-soDienThoai">Số điện thoại</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-soDienThoai" class="form-control">
                                        </div>
                                    </div>
                                    <!-- địa chỉ -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-dia-chi">Địa chỉ</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-dia-chi" class="form-control">
                                        </div>
                                    </div>
                                    <!-- id voucher -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-idVourcher">Id voucher</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-idVourcher" class="form-control">
                                        </div>
                                    </div>
                                    <!-- giảm giá -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-giamGia">Giảm Giá</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-giamGia" class="form-control">
                                        </div>
                                    </div>
                                    <!-- ngày tạo -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-ngayTao">Ngày tạo</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-ngayTao" class="form-control">
                                        </div>
                                    </div>
                                    <!-- ngày cập nhật -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-ngayCapNhat">Ngày cập nhật</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-ngayCapNhat" class="form-control">
                                        </div>
                                    </div>
                                    <!-- lời nhắn -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-loiNhan">Lời nhắn</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-loiNhan" class="form-control">
                                        </div>
                                    </div>
                                    <!-- kích cỡ -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-kichCo">Kích cỡ</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-kichCo" class="form-control">
                                        </div>
                                    </div>
                                    <!-- đường kính -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-duong-kinh">Đường kính</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-duong-kinh" class="form-control">
                                        </div>
                                    </div>
                                    <!-- sườn -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-suon">Sườn</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-suon" class="form-control">
                                        </div>
                                    </div>
                                    <!-- salad -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-salad">Salad</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-salad" class="form-control">
                                        </div>
                                    </div>
                                    <!-- số lượng nước -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-soLuongNuoc">Số lượng nước</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-soLuongNuoc" class="form-control">
                                        </div>
                                    </div>
                                    <!-- thành tiền -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-thanhTien">Thành tiền</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-thanhTien" class="form-control">
                                        </div>
                                    </div>
                                    <!-- loại pizza -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-loaiPizza">Loại Pizza</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-loaiPizza" class="form-control">
                                        </div>
                                    </div>
                                    <!-- id loại nươc uóng -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-idLoaiNuocUong">Id Loại nước uống</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input readonly type="text" id="inp-idLoaiNuocUong" class="form-control">
                                        </div>
                                    </div>
                                    <!-- trạng thái -->
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="inp-trangThai">Trạng thái</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <select class="form-control" id="inp-trangThai">
                                                <option value="open">Open</option>
                                                <option value="confirmed">Đã xác nhận</option>
                                                <option value="cancel">Đã hủy</option>
                                            </select>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button class="btn btn-success" id="btn-confirm">Update</button>
                                <button class="btn btn-warning" id="btn-cancel" data-dismiss="modal">Cancel</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- modal xóa -->
            <div>
                <div id="delete-order-modal" class="modal fade" tabindex="-1">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title text-danger" id="h5-modal-title">Delete Order</h5>
                                <button class="close" data-dismiss="modal">&times;</button>
                            </div>
                            <div class="modal-body">
                                <form>
                                    <div class="row form-group">
                                        <h4 class="text-danger"><b>Bạn có chắc muốn xóa đơn hàng này!!</b></h4>
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button class="btn btn-danger" id="btn-modal-delete">Xóa đơn hàng</button>
                                <button class="btn btn-success" id="btn-cancel" data-dismiss="modal">Cancel</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- /.content -->
        </div>
        <!-- /.content-wrapper -->
        <footer class="main-footer">
            <strong>Copyright &copy; 2014-2021 Devcamp.</strong>
            All rights reserved.
            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
    </div>

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- Select2 -->
    <script src="plugins/select2/js/select2.full.min.js"></script>
    <!-- data table -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>
    <script src="orderdetail.js"></script>
    <script>
        // Modal select 2 
        $('.select2').select2()
        //Initialize Select2 Elements
        $('.select2bs4').select2({
            theme: 'bootstrap4'
        })        
    </script>
</body>
</script>
</body>


<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
    const gBASE_URL_DRINK = "http://42.115.221.44:8080/devcamp-pizza365/drinks";

    var gAllOrder = [];
    var gOrder = {};
    var gOrderId = "";
    var gId = "";
    const gOrderData = ["STT", "orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "chitiet"];
    const gSTT = 0;
    const gORDER_ID_COL = 1;
    const gKICH_CO_COL = 2;
    const gLOAI_PIZZA_COL = 3;
    const gNUOC_UONG_COL = 4;
    const gTHANH_TIEN_COL = 5;
    const gHO_TEN_COL = 6;
    const gSDT_COL = 7;
    const gTRANG_THAI_COL = 8;
    const gCHI_TIET_COL = 9;
    var stt = 1;
    var gCombo = [
        {
            kichCo: "S",
            duongKinh: 20,
            suon: 2,
            salad: "200g",
            soLuongNuoc: 2,
            thanhTien: 150000,
        },
        {
            kichCo: "M",
            duongKinh: 25,
            suon: 4,
            salad: "300g",
            soLuongNuoc: 3,
            thanhTien: 200000,
        },
        {
            kichCo: "L",
            duongKinh: 30,
            suon: 8,
            salad: "500g",
            soLuongNuoc: 4,
            thanhTien: 250000,
        }
    ]

    var gOrderTable = $("#course-table").DataTable({
        columns: [
            { data: gOrderData[gSTT] },
            { data: gOrderData[gORDER_ID_COL] },
            { data: gOrderData[gKICH_CO_COL] },
            { data: gOrderData[gLOAI_PIZZA_COL] },
            { data: gOrderData[gNUOC_UONG_COL] },
            { data: gOrderData[gTHANH_TIEN_COL] },
            { data: gOrderData[gHO_TEN_COL] },
            { data: gOrderData[gSDT_COL] },
            { data: gOrderData[gTRANG_THAI_COL] },
            { data: gOrderData[gCHI_TIET_COL] }
        ],
        columnDefs: [
            {
                targets: gSTT,
                className: "d-lg-none",
                render: function () {
                    return stt++
                }
            },
            {
                targets: gCHI_TIET_COL,
                defaultContent:
                    `
            <i class="fa-solid fa-pen-to-square text-info btn-detail mr-4" data-toggle="tooltip" title="Cập nhật trạng thái"></i> 
            <i class="fa-regular fa-trash-can text-danger btn-delete" data-toggle="tooltip" title="Xóa"></i>
            `

            }
        ]
    })
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
        // call api lấy tất cả order
        callApiGetAllOrder();

        //call api lấy các loại nước uống
        callApiGetDrink();

        // cập nhật bảng
        loadDataIntoTable(gAllOrder);
    })

    // hàm nhấn nút lọc
    $("#btn-filter").click(function () {
        "use strict";
        var vDataFilter = {
            trangThai: "",
            loaiPizza: ""
        }

        // lấy dữ liệu từ ô select
        getDataOrderFilter(vDataFilter);
        // kiểm tra

        // lọc dữ liệu
        var vFilter = filterOrder(vDataFilter);

        // hiển thị ra bảng
        loadDataIntoTable(vFilter)

    })

    // hàm nhấn nút thêm order
    $(".insert-order").click(function () {
        $("#inp-insert-giamgia").val(0);
        $("#insert-order-modal").modal("show");
    })

    // hàm lắng nghe khi select kích cỡ thay đổi
    $("#inp-insert-kichCo").on("change", function () {
        // hàm gán dữ liệu vào ô input
        addDataToInput()
    })

    // hàm nhấn nút thêm order
    $("#btn-insert-order").click(function () {
        "use strict";
        var vNewOrder = {
            kichCo: "",
            duongKinh: 0,
            suon: 0,
            salad: 0,
            loaiPizza: "",
            idVourcher: 0,
            idLoaiNuocUong: "",
            soLuongNuoc: 0,
            hoTen: "",
            thanhTien: 0,
            email: "",
            soDienThoai: "",
            diaChi: "",
            loiNhan: ""
        }
        // thu thập dữ liệu 
        getDataInsertOrder(vNewOrder);
        // kiểm tra thông tin đơn hàng
        var vValidate = validateOrder(vNewOrder);
        if (vValidate) {
            // call api tạo mới order
            callAPiCreateOrder(vNewOrder);
            // call api lấy danh sách order mới
            callApiGetAllOrder()
            // cập nhật bảng
            loadDataIntoTable(gAllOrder)
            // ẩn modal
            $("#insert-order-modal").modal("hide");
        }
    })
    // hàm nhấn nút cập nhật trạng thái
    $(document).on("click", ".btn-detail", function () {
        // lấy order id và id của order
        getOrderIdAndId(this);
        // call api lấy thông tin order
        callApiGetDataOrder();
        // hiện modal
        $("#detail-order-modal").modal("show");
    })
    // hàm nhấn nút update
    $("#btn-confirm").click(function () {
        var vObjectRequest = {
            trangThai: "" //3 trang thai open, confirmed, cancel
        }
        // thu thập thông tin order update trạng thái
        getDataOrderByModal(vObjectRequest);
        // gọi api confirm order
        callApiUpdateOrder(vObjectRequest);
        // call api lấy danh sách order mới
        callApiGetAllOrder()
        // cập nhật bảng
        loadDataIntoTable(gAllOrder)
        // ẩn modal
        $("#detail-order-modal").modal("hide");
    })
    // hàm nhân nút xóa
    $(document).on("click", ".btn-delete", function () {
        // lấy order id và id của order
        getOrderIdAndId(this);
        // hiện modal
        $("#delete-order-modal").modal("show")
    })
    // hàm nhấn nút xóa đơn hàng
    $("#btn-modal-delete").click(function () {
        // call api xóa order
        callApiDeleteOrder();
        // call api lấy danh sách order mới
        callApiGetAllOrder()
        // cập nhật bảng
        loadDataIntoTable(gAllOrder)
        // ẩn modal 
        $("#delete-order-modal").modal("hide")
    })
    $("#inp-insert-idVourcher").on("keyup", function () {
        console.log($("#inp-insert-idVourcher").val().length)
        if ($("#inp-insert-idVourcher").val().length === 5) {
            // call api check mã
            callAPiCheckVoucer($("#inp-insert-idVourcher").val())
        }
        else {
            $("#inp-insert-giamgia").val(0)
        }
    })


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    // call api get all order
    function callApiGetAllOrder() {
        "use strict";
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            async: false,
            success: function (res) {
                gAllOrder = res
            },
            error: function () {
                console.log(res.status)
            }
        })
    }
    function callApiGetDrink() {
        "use strict";
        $.ajax({
            url: gBASE_URL_DRINK,
            type: "GET",
            success: function (res) {
                loadDataDirkToSelect(res);
            },
            error: function (res) {
                console.log(res.status)
            }
        })
    }
    // hàm hiện thông tin lên bảng
    function loadDataIntoTable(paramCourse) {
        "use strict";
        gOrderTable.clear();
        gOrderTable.rows.add(paramCourse);
        gOrderTable.draw();
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    // hàm lấy thông tin từ ô select
    function getDataOrderFilter(paramDataFilter) {
        "use strict";
        paramDataFilter.trangThai = $("#status-order-select").val();
        paramDataFilter.loaiPizza = $("#pizza-select").val();
        console.log(paramDataFilter)
    }

    // lọc dữ liệu
    function filterOrder(paramDataFilter) {
        "use strict";
        var vOrderFilter = [];
        vOrderFilter = gAllOrder.filter(function (paramOrder) {
            if (paramOrder.trangThai != null && paramOrder.loaiPizza != null) {
                // debugger;
                return ((paramOrder.trangThai.includes(paramDataFilter.trangThai) || paramDataFilter.trangThai == "none")
                    && (paramOrder.loaiPizza.includes(paramDataFilter.loaiPizza) || paramDataFilter.loaiPizza == "none"));
            }
        });
        return vOrderFilter;
    }

    // lấy order id và id của order
    function getOrderIdAndId(paramOrder) {
        "use strict";
        var vCourseChange = gOrderTable.row($(paramOrder).parents("tr")).data();
        gOrderId = vCourseChange.orderId;
        gId = vCourseChange.id;
        console.log(vCourseChange)
        console.log("orderID: " + gOrderId);
        console.log("ID: " + gId);
    }

    // call api lấy thông tin order
    function callApiGetDataOrder() {
        "use strict";
        $.ajax({
            url: gBASE_URL + "/" + gOrderId,
            type: "GET",
            success: function (res) {
                console.log(res)
                gOrder = res;
                // hiển thị thông tin lên modal
                showDataOrderDetailToModal(res);
            },
            error: function (res) {
                console.log(res.status);
            }
        })
    }

    // hiển thị thông tin lên modal
    function showDataOrderDetailToModal(paramOrderDetail) {
        "use strict";
        $("#inp-dia-chi").val(paramOrderDetail.diaChi);
        $("#inp-duong-kinh").val(paramOrderDetail.duongKinh);
        $("#inp-email").val(paramOrderDetail.email);
        $("#inp-giamGia").val(paramOrderDetail.giamGia);
        $("#inp-hoTen").val(paramOrderDetail.hoTen);
        $("#inp-idLoaiNuocUong").val(paramOrderDetail.idLoaiNuocUong);
        $("#inp-idVourcher").val(paramOrderDetail.idVourcher);
        $("#inp-kichCo").val(paramOrderDetail.kichCo);
        $("#inp-loaiPizza").val(paramOrderDetail.loaiPizza);
        $("#inp-trangThai").val(paramOrderDetail.trangThai);
        $("#inp-loiNhan").val(paramOrderDetail.loiNhan);
        $("#inp-ngayCapNhat").val((paramOrderDetail.ngayCapNhat));
        $("#inp-ngayTao").val((paramOrderDetail.ngayTao));
        $("#inp-orderId").val(paramOrderDetail.orderId);
        $("#inp-salad").val(paramOrderDetail.salad);
        $("#inp-soDienThoai").val(paramOrderDetail.soDienThoai);
        $("#inp-soLuongNuoc").val(paramOrderDetail.soLuongNuoc);
        $("#inp-suon").val(paramOrderDetail.suon);
        $("#inp-thanhTien").val(paramOrderDetail.thanhTien);
    }

    // hàm lấy thông tin order dựa vào modal
    function getDataOrderByModal(paramTrangThai) {
        paramTrangThai.trangThai = $("#inp-trangThai").val();
    }

    // hàm kiểm tra thông tin trước khi tạo order
    function validateOrder(paramOrderConfirm) {
        "use strict";
        console.log(paramOrderConfirm)
        if (paramOrderConfirm.kichCo == "none") {
            alert("hãy chọn kích cỡ!");
            return false;
        }
        if (paramOrderConfirm.loaiPizza == "none") {
            alert("hãy chọn loại pizza!");
            return false;
        }
        if (paramOrderConfirm.idVourcher != "") {
            if (isNaN(paramOrderConfirm.idVourcher)) {
                alert("hãy mã voucher là số!");
                return false;
            }
        }
        if (paramOrderConfirm.idLoaiNuocUong == "none") {
            alert("hãy chọn loại nước uống!");
            return false;
        }
        if (isNaN(paramOrderConfirm.hoTen) == false || paramOrderConfirm.hoTen == "") {
            alert("hãy nhập tên của bạn!");
            return false;
        }
        if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(paramOrderConfirm.email)) {
        } else {
            alert("hãy nhập emaill đúng!")
            return false;
        }
        if (paramOrderConfirm.soDienThoai == "" || isNaN(paramOrderConfirm.soDienThoai) == true) {
            alert("hãy nhập số điện thoại!");
            return false;
        }
        if (paramOrderConfirm.diaChi == "") {
            alert("hãy nhập địa chỉ!");
            return false;
        }
        return true
    }

    // call api confirm order
    function callApiUpdateOrder(paramTrangThai) {
        "use strict";
        console.log(paramTrangThai);
        console.log(gId)
        $.ajax({
            url: gBASE_URL + "/" + gId,
            type: "PUT",
            async: false,
            contentType: "application/json",
            data: JSON.stringify(paramTrangThai),
            success: function (res) {
                console.log(res);
            },
            error: function (res) {
                console.log(res.status);
            }
        })
    }

    // call api xóa order
    function callApiDeleteOrder() {
        "use strict";
        $.ajax({
            url: gBASE_URL + "/" + gId,
            type: "DELETE",
            success: function (res) {
                console.log(res)
            },
            error: function (res) {
                console.log(res.status)
            }
        })
    }

    // hàm gán dữ liệu vào ô input
    function addDataToInput() {
        "use strict";
        for (var i = 0; i < gCombo.length; i++) {
            if ($("#inp-insert-kichCo").val() === "none") {
                $("#inp-insert-duong-kinh").val("");
                $("#inp-insert-suon").val("");
                $("#inp-insert-salad").val("");
                $("#inp-insert-soLuongNuoc").val("");
                $("#inp-insert-thanhTien").val("");
            }
            if ($("#inp-insert-kichCo").val() === gCombo[i].kichCo) {
                $("#inp-insert-duong-kinh").val(gCombo[i].duongKinh);
                $("#inp-insert-suon").val(gCombo[i].suon);
                $("#inp-insert-salad").val(gCombo[i].salad);
                $("#inp-insert-soLuongNuoc").val(gCombo[i].soLuongNuoc);
                $("#inp-insert-thanhTien").val(gCombo[i].thanhTien);
            }
        }
    }

    // hàm thu thập dữ liệu tạo order mới
    function getDataInsertOrder(paramNewOrder) {
        "use strict";
        paramNewOrder.kichCo = $("#inp-insert-kichCo").val().trim();
        paramNewOrder.duongKinh = $("#inp-insert-duong-kinh").val().trim();
        paramNewOrder.suon = $("#inp-insert-suon").val().trim();
        paramNewOrder.salad = $("#inp-insert-salad").val().trim();
        paramNewOrder.loaiPizza = $("#inp-insert-loaiPizza").val().trim();
        paramNewOrder.idVourcher = $("#inp-insert-idVourcher").val().trim();
        paramNewOrder.idLoaiNuocUong = $("#inp-insert-idLoaiNuocUong").val().trim();
        paramNewOrder.soLuongNuoc = $("#inp-insert-soLuongNuoc").val().trim();
        paramNewOrder.hoTen = $("#inp-insert-hoTen").val().trim();
        paramNewOrder.thanhTien = $("#inp-insert-thanhTien").val().trim();
        paramNewOrder.email = $("#inp-insert-email").val().trim();
        paramNewOrder.soDienThoai = $("#inp-insert-soDienThoai").val().trim();
        paramNewOrder.diaChi = $("#inp-insert-dia-chi").val().trim();
        paramNewOrder.loiNhan = $("#inp-insert-loiNhan").val().trim();
    }

    // hàm load dữ liệu nước uống vào select'
    function loadDataDirkToSelect(paramDrink) {
        "use strict";
        $("#inp-insert-idLoaiNuocUong").append(`<option value="none">--Hãy chọn loại nước uống</option>`)
        for (var i = 0; i < paramDrink.length; i++) {
            $("#inp-insert-idLoaiNuocUong").append(`<option value="${paramDrink[i].maNuocUong}">${paramDrink[i].tenNuocUong}</option>`)
        }
    }

    // call api tạo mới order
    function callAPiCreateOrder(paramNewOrder) {
        "use strict";
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json",
            data: JSON.stringify(paramNewOrder),
            success: function (res) {
                console.log(res)
            },
            error: function (res) {
                console.log(res.status)
            }
        })
    }

    // call api check voucher
    function callAPiCheckVoucer(paramVoucherId) {
        "use strict";
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail/" + paramVoucherId,
            type: "GET",
            async: false,
            success: function (res) {
                console.log(res.phanTramGiamGia)
                $("#inp-insert-giamgia").val((res.phanTramGiamGia / 100) * $("#inp-insert-thanhTien").val())
            },
            error: function (res) {
                console.log(res.status)
            }
        })
    }
//-----------------------------------------/////
</script>

</html>